// Contient les fonctions du jeu

// Randomisateur 
#define RAND_MAX 0x7FFFU
#define NULL 0
#define random(num)(int)(((long)rand()*(num))/(RAND_MAX+1))
#define randomize()     srand((unsigned)time(NULL))

/* "HardWare" */

// Initialisation de la G100
void init_G100(void)
{
 // Desact de l' int 9
 disable9();

 dbclear(VIEWSEG1); 
 dbclear(VIEWSEG2);
 
 // On change le mode
 mode(0xDB);

 // On sauvegarde le contrast actuelle
 anc_contrast= get_contrast();

 // On augmente le contrast
 game_contrast= 16;
 contrast(16);

}

// Quitter proprement
void quit_G100(void)
{
 dbclear(VIEWSEG1); 
 dbclear(VIEWSEG2);
 movevideo(VIEWSEG1);
 mode(0xC3);
 contrast(anc_contrast);
 enable9();
 emptybuf();
}

/* Dessin */

// Rafraichissement de l' cran (avec en comment un essai foireux de page flipping ;p )
void refresh(void)
{
 dbcopyscreen(buffer, VIEWSEG1);
 /*movevideo(buffer);

 if (buffer != VIEWSEG1)
 {
  buffer=  VIEWSEG1;
 }
 else
 {
  buffer= VIEWSEG2;
 }*/
 //buffer ^= 0x0040;
}

// Pour dessiner un sprite 8x8.
void drawgsprite8(int x, int y, _gsprite8 *sprite)
{
 d8clip_or(x, y, sprite->c1, buffer);
 d8clip_or(x, y, sprite->c2, buffer + 0x80);
}

/* Initialisation des entites du jeu */

// Pour initialiser une baballe
void initball(balldef *ball, char x, char y, _gsprite8 *sp)
{
 ball->pos.x= x;	   
 ball->pos.y= y;
 ball->pos.s=  ball->ancpos.s= ball->ancpos2.s= sp;
 ball->ancpos.x= x;
 ball->ancpos.y= y;
 ball->dx= 0;
 ball->dy= 0;  
 ball->score= 0;
 ball->mode= MODE_NONE;
}

// Pour initialiser le bonus
void init_bonus(bonusdef *bonus)
{
 bonus->activ= 0;
}

/* Initialisation du jeu */

void init_game_1Phard(void)
{
 initball(&balle, 56, 0, &s_balle);
 initmap();
 mapoffset= 0;
 bandemap= 0;
 randomize();
 mur_lmax= 4;
 mur_tmax= 3;
 mur_tplus= 0; 
 game_speed= 1000;
 game_defaultspeed= 1000;
 game_physicspeed= 2;
 init_bonus(&bonus1);
} 

void init_game_1P(void)
{
 initball(&balle, 56, 0, &s_balle);
 initmap();
 mapoffset= 0;
 bandemap= 0;
 randomize();
 mur_lmax= 4;
 mur_tmax= 3;
 mur_tplus= 0; 
 game_speed= 0;
 game_defaultspeed= 0;
 game_physicspeed= 1;
 init_bonus(&bonus1);
} 

void init_game_2P(void)
{
 initball(&balle, 36, 0, &s_balle);
 initball(&balle2, 74, 0, &s_balle2);
 initmap();
 mapoffset= 0;
 bandemap= 0;
 randomize();
 mur_lmax= 4;
 mur_tmax= 3;
 mur_tplus= 0; 
 game_speed= 0;
 game_defaultspeed= 500;
 game_physicspeed= 2;
 init_bonus(&bonus1);
} 

/* Routines diverses du jeu */

// Le carr de taille 8x8 est il en dehors de l cran?
// Me semble que cette fonction n' est meme pas utilise x_x
char collmap(int x,int y)
{
 if ((x < 0) ||
     ((x + 7) > 127) ||
	 (y < 0) ||
	 ((y + 7 > 63))) return 1;
 return 0;
}

// La balle est elle en dehors de l' cran?
char testball(balldef *ball)
{
 if ((ball->pos.x < 0) ||
	 (ball->pos.x + 7 > 127) ||
	 (ball->pos.y < 0) ||
	 (ball->pos.y + 7 > 63)) return 1;
 return 0;
}

// Le carr de taille 8x8 et de position x, y est il en collision avec la map?
char testmap(char x, char y)
{
 char i, ym, bande;
 // Si la nouvelle position est sur une bande...
 // position d' une bande i: y= (i * 16) - mapoffset
 // Numero de bande: bande= (i + bandemap) % 5
 //	on peut faire varier i de 0  5 pour trouver directement la position
 for( i= 0; i < 5; i++)
 {
  bande= (i + bandemap) % 5; // On obtient la bande
  ym= (i * 16) - mapoffset + 1;   // On obtient la position en y de cette bande
  // On test si on est dans une bande
  if (((y + 7) >= ym) &&
      (y <= (ym + 5))    )
  {
   // On test le bloc
   if (map[bande][(x / 8)])
   {
	// Si ya collision avec un bloc de 6 de largeur
	return 1;
   }
   // On test le bloc d'  cot s' il doit tre test
   if ((x % 8))
   {
    if (map[bande][((x / 8) + 1)])
    {
	 return 1;
    }
   }
  }
 }
 return 0;
}

// On bouge la balle en X
// dx est le dplacement en pixel
// mulcons doit tre  1 pour que il y ait dplacement
void moveballx(balldef *ball, char mulcons, char dx)
{
 ball->pos.x+= dx;
 if (ball->pos.x < 0)
 {
  // On modifie dx
  dx= ball->pos.x + dx;
  ball->pos.x= 0;
 }
 else
 if (ball->pos.x > 120)
 {
  // On modifie dx
  dx= 120 - (ball->pos.x + dx);
  ball->pos.x= 120;
 }
 if ((mulcons && testmap(ball->pos.x, ball->pos.y)))
 {
  ball->pos.x-= dx;
 }
}

// On bouge la balle en Y
// dy est le dplacement en pixel
// mulcons doit tre  1 pour que il y ait dplacement
void movebally(balldef *ball, char mulcons, char dy)
{
 ball->pos.y+= dy;
 if (ball->pos.y < 0)
 {
  // On modifie dx
  dy= ball->pos.y + dy;
  ball->pos.y= 0;
 }
 else
 if (ball->pos.y > 56)
 {
  // On modifie dx
  dy= 56 - (ball->pos.y + dy);
  ball->pos.y= 56;
 }
 if ((mulcons && testmap(ball->pos.x, ball->pos.y)))
 {
  ball->pos.y-= dy;
 }
}

// On fait tomber la balle
void gravite(balldef *ball)
{
 movebally(ball, (ball->mode != MODE_GHOST), 1);
}

// On fait tomber la balle, en regardant si ya pas une autre balle en dessous
void gravite2(balldef *ball, balldef *ball2)
{
 movebally(ball, (ball->mode != MODE_GHOST), 1);
 if (testball2ball(ball, ball2)) ball->pos.y-= 1;
}

#define BALL_MOV 1

// On bouge la balle.
// gauche = commande gauche
// droite = commande droite
// J' aurais pu mettre directement des testkey, mais en prvision d' une IA, j' ai plutot mis ceci.
void physicball(balldef *ball, char gauche, char droite)
{
 // Scrolling
 if (ball->pos.y > 0) ball->pos.y--;
 //else perdu= 1;
 // Gravit
 gravite(ball);
 gravite(ball);
 ball->score++;
 if (gauche)
 {
  /*if (ball->pos.x > 0) 
  {
   ball->pos.x-=BALL_MOV;
   if (ball->mode != MODE_GHOST) if (testmap(ball->pos.x, ball->pos.y)) ball->pos.x+=BALL_MOV;
  }*/
  moveballx(ball, (ball->mode != MODE_GHOST), -1);
 }
 else
 if (droite)
 {
  /*if (ball->pos.x + 7 < 127) 
  {
   ball->pos.x+=BALL_MOV;
   if (ball->mode != MODE_GHOST) if (testmap(ball->pos.x, ball->pos.y)) ball->pos.x-=BALL_MOV;
  }*/
  moveballx(ball, (ball->mode != MODE_GHOST), 1);
 }
} 

// Les balles sont elles en collision?
char testball2ball(balldef *ball1, balldef *ball2)
{
 char x1, x2, y1, y2;
 unsigned long distance;
 x1= ball1->pos.x;
 y1= ball1->pos.y;
 x2= ball2->pos.x;
 y2= ball2->pos.y;

 // 1 balle fait 5 pixel de diamtre
 // Donc la collision se fait s' il y a 10 pixel de distance entre les centres des balles
 // On calcule la distance
 distance= ((x2 - x1) * (x2 - x1)) + ((y2 - y1) * (y2 - y1));
 if (distance <= 81) return 1;
 return 0;
}

// On bouge la balle, en tenant compte qu' une autre balle est en jeu
void physicball2(balldef *ball, balldef *ball2, char gauche, char droite)
{
 // Scrolling
 //if (ball->pos.y > 0) ball->pos.y--;
 movebally(ball, 0, -1);
 if (testball2ball(ball, ball2)) ball->pos.y+= 1;

 //else perdu= 1;
 // Gravit
 gravite2(ball, ball2);
 gravite2(ball, ball2);
 ball->score++;
 if (gauche)
 {
  moveballx(ball, (ball->mode != MODE_GHOST), -1);
  if (testball2ball(ball, ball2)) ball->pos.x+= 1;
 }
 else
 if (droite)
 {
  moveballx(ball, (ball->mode != MODE_GHOST), 1);
  if (testball2ball(ball, ball2)) ball->pos.x-= 1;
 }
} 

// Pour amliorer l' affichage, on sauvegarde la position
void savepos(balldef *ball)
{
 ball->ancpos2.x= ball->ancpos.x;
 ball->ancpos2.y= ball->ancpos.y;
 ball->ancpos.x= ball->pos.x;
 ball->ancpos.y= ball->pos.y;
}

// dessin d' un objet de 8x8
void drawobj(spr8def *et)
{
 drawgsprite8(et->x, et->y, et->s);
}
  
// Attente
void temps(unsigned long j)
{
 for(;j>0;j--);
}

// Affichage de la map
void drawmap(void)
{
 // 1 On affiche les 5 bandes dans tout les cas
 // 2 On les affiche  partir du bas en rajoutant offset et en enlevant 1 bande donc 16 pixel
 // 3 On dessine les bandes en boucles
 char bande, i, j;
 for(i= 0; i < 5; i++)
 {
  bande= i + bandemap; // Dessin  partir de la bande de map

  // Pour viter de depasser
  bande= bande % 5;

  for(j= 0; j < 16; j++)
  {
   if (map[bande][j]) drawgsprite8((j * 8), (i * 16) - mapoffset, &s_bloc);
   else	drawgsprite8((j * 8), (i * 16) - mapoffset, &s_vide);
  }
 }
}

// Initialisation de la map
void initmap(void)
{
 // 1 On affiche les 5 bandes dans tout les cas
 // 2 On les affiche  partir du bas en rajoutant offset et en enlevant 1 bande donc 16 pixel
 // 3 On dessine les bandes en boucles
 char i, j;
 for(i= 0; i < 5; i++)
 {
  for(j= 0; j < 16; j++)
  {
   map[i][j]= 0;
  }
 }
}

// Gestion d' un bonus
void handlebonus(bonusdef *bonus)
{
 // activ < 0  -> Bonus activ
 // activ == 0 -> Bonus inactif
 // activ > 0  -> Bonus enclanch

 if (bonus->activ > 0) // Si le bonus est en activit de monte
 {
  bonus->pos.y--;
  if (bonus->pos.y < -7)
  {
   bonus->activ= 0;
   return;
  }
 }
 else
 if (bonus->activ < 0) // Si le bonus est en actif
 {
  bonus->activ++;
  switch(bonus->type)
  {
  case 0: // bonus de point
   bonus->ball->score+= 100;
   break;
  case 1:
   initmap();
   break;
  case 2:
   bonus->ball->mode= MODE_FASTER;
   break;
  case 3:
   bonus->ball->mode= MODE_GHOST;
   if (!(bonus->activ)) if (testmap(balle.pos.x,balle.pos.y)) bonus->activ--;
   break;
  case 4:
   mur_tplus= 2; 
   break;
  case 5:
   game_speed+=500;
   break;
  case 6:
   bonus->ball->score++;
   break;
  }
 }
}

// Voir si la balle touche un bonus
void ballandbonus(balldef *ball, bonusdef *bonus)
{
 // Detection de la balle et du bonus
 int xba= ball->pos.x, yba= ball->pos.y, xbo= bonus->pos.x, ybo= bonus->pos.y;
 if ((xba + 7 >= xbo) && (xba <= xbo + 7) && (yba + 7 >= ybo) && (yba <= ybo + 7))
 {
  ball->score+= BONUS_PICKUP;
  bonus->ball= ball;
  bonus->activ= -bonus->activ;
 }
}

// Fonction de decalage de la map
// Le plus dur  faire avec la fonction de detection des murs, mais en outre le plus interressant
void decalmap(bonusdef *bonus)
{
 char j, i;
 mapoffset++;
 mapoffset= mapoffset & 0x0F;
 if (mapoffset == 0) 
 {
  bandemap++;
  bandemap= bandemap % 5;
 }
 if (mapoffset == 8)
 {
  if (bonus->activ == 0) // Si le bonus est inactif
  {
   // On regarde si un bonus peut tre gnr
   //if (!random(BONUS_RESPAWN))
   {
	char type;
	type= random(BONUSTYPE_MAX);
	bonus->type= type;
	bonus->pos.s= &s_allbonus[type];
	bonus->pos.y= 66;
	bonus->pos.x= 33 + random((63 - 33 - 4)) * 2;
	//bonus->activ= 1;
	bonus->activ= bonustype[type].time;
   }
  }
  
  j= 0;
  while(j < 16)
  {
   i= 1 + random(mur_lmax) + j;
   if (i > 16) i= 16;
   for(; j < i; j++) map[bandemap][j]= 1;
   i= 1 + random(mur_tmax + mur_tplus) + j;
   if (i > 16) i= 16;
   for(; j < i; j++) map[bandemap][j]= 0;
  }
 }
 mur_tplus= 0; 
 handlebonus(bonus);
}

// Dessiner un caractere
// Color: 0 rien
//        1 gris
//        2 noir
void drawchar(short x, short y, char c, char color)
{
 char nc= 0;
 if (c >= 48 && c <= 57) nc= c - 48;
 else
 if (c >= 65 && c <= 90) nc= c - 55;
 else
 if (c == ' ') nc= 36;
 else
 if (c == ':') nc= 37;
 else
 if (c == '?') nc= 38;
 else
 if (c == '.') nc= 39;
 else
 if (c == '!') nc= 40;
 if (color >= 1) d8clip_or(x, y, alpha[nc], buffer);
 if (color == 2) d8clip_or(x, y, alpha[nc], (buffer + 0x80));
}

// Affichage d' une chaine de caractre
void draw_string(short x, short y, char *str, char color)
{
 char i;
 for(i= 0; str[i] != 0; i++)
 {
 	drawchar(x, y, str[i], color);
 	x+= 5;
 }
}

// Affichage d' un chiffre
void draw_number(short x, short y, int n, short l, char color)
{
 short i,d= 0;
 int r= n;
 char st[10];/*a voir*/
 if(r < 0) r= -r;
 for(i= (l - 1); i >= 0; i--)
 {
  if ((r == 0) && (i != (l-1)))
  {
   d++;
   st[i]= ' ';
  }
  else st[i]= (48 + r%10);
  r/= 10;
 }
 //if(n<0) st[d-1]='-';
 st[l]= '\0';
 draw_string(x, y, st, color);
}

// Attendre la pression puis le relachement de la touche
void waitkey(char x, char y)
{
 while(!testkey(x, y));
 while(testkey(x, y)) while(testkey(x, y));
}

#define GAME_1P 0
#define GAME_2P 1

// Gestion de la balle
void gererball(balldef *ball, bonusdef *bonus, char gauche, char droite)
{
 char x= game_physicspeed;
 for(; x > 0; x--)
 {
  decalmap(bonus);
  physicball(ball, gauche, droite);
  if (ball->mode == MODE_FASTER) physicball(ball, gauche, droite);
 }
}

// Gestion de la balle en tenant compte d' une autre balle
void gererball2(bonusdef *bonus,
				balldef *ball1, char gauche1, char droite1,
				balldef *ball2, char gauche2, char droite2)
{															 
 char x= game_physicspeed;
 for(; x > 0; x--)
 {
  decalmap(bonus);

  physicball2(ball1, ball2, gauche1, droite1);
  if (ball1->mode == MODE_FASTER) physicball2(ball1, ball2, gauche1, droite1);
  physicball2(ball2, ball1, gauche2, droite2);
  if (ball2->mode == MODE_FASTER) physicball2(ball2, ball1, gauche2, droite2);
 }
}

// Physique du jeu gnrique
void physicall(char mode)
{
 switch(mode)
 {
 case GAME_1P:
  balle.mode= MODE_NONE;
  savepos(&balle);

  /*decalmap(&bonus1);
  physicball(&balle, testkey(K_LEFT), testkey(K_RIGHT));
  if (balle.mode == MODE_FASTER) physicball(&balle, testkey(K_LEFT), testkey(K_RIGHT));

  decalmap(&bonus1);
  physicball(&balle, testkey(K_LEFT), testkey(K_RIGHT));
  if (balle.mode == MODE_FASTER) physicball(&balle, testkey(K_LEFT), testkey(K_RIGHT));*/
  gererball(&balle, &bonus1, testkey(K_F1), testkey(K_F6));
  //gererball(&balle, &bonus1, testkey(K_F1), testkey(K_F6));
  //gererball(&balle, &bonus1, testkey(K_F1), testkey(K_F6));

  break;
 case GAME_2P:
  savepos(&balle);
  savepos(&balle2);

  /*decalmap(&bonus1);

  physicball2(&balle, &balle2, testkey(K_0), testkey(K_POINT));
  if (balle.mode == MODE_FASTER) physicball2(&balle, &balle2, testkey(K_0), testkey(K_POINT));
  physicball2(&balle2, &balle, testkey(K_LITTLEMINUS), testkey(K_EXE));
  if (balle2.mode == MODE_FASTER) physicball2(&balle2, &balle, testkey(K_LITTLEMINUS), testkey(K_EXE));

  decalmap(&bonus1);

  physicball2(&balle, &balle2, testkey(K_0), testkey(K_POINT));
  if (balle.mode == MODE_FASTER) physicball2(&balle, &balle2, testkey(K_0), testkey(K_POINT));
  physicball2(&balle2, &balle, testkey(K_LITTLEMINUS), testkey(K_EXE));
  if (balle2.mode == MODE_FASTER) physicball2(&balle2, &balle, testkey(K_LITTLEMINUS), testkey(K_EXE));*/

  gererball2(&bonus1, &balle, testkey(K_0), testkey(K_POINT), &balle2, testkey(K_LITTLEMINUS), testkey(K_EXE));

  break;
 }

 {
  if (bonus1.activ > 0) ballandbonus(&balle, &bonus1);
  if (bonus1.activ > 0) ballandbonus(&balle2, &bonus1);
 }
}

// Affichage du jeu gnrique
void drawall(char mode)
{
 dbclear(buffer);
   
 drawmap();

 drawobj(&balle.pos);
 drawobj(&balle.ancpos);
 drawobj(&balle.ancpos2);
 draw_number(0, 0, balle.score, 6, 2);

 if (mode == GAME_2P)
 {
 drawobj(&balle2.pos);
 drawobj(&balle2.ancpos);
 drawobj(&balle2.ancpos2);
 draw_number(128 - (5 * 6), 0, balle2.score, 6, 2);
 }

 {
  if (bonus1.activ > 0) drawobj(&bonus1.pos);
 }
 //draw_string(0, 6, nameofbonus[bonus1.type], 2);
 //draw_number(0, 12, bonus1.activ, 3, 2);
 refresh();
}   

char loser;

// Voir si le jeu est termin
char testfinish(char mode)
{
 if (balle.mode != MODE_GHOST) if (testmap(balle.pos.x,balle.pos.y))
 {
  loser= 0;
  return 1;
 }
 if (mode == GAME_2P) if (balle2.mode != MODE_GHOST) if (testmap(balle2.pos.x,balle2.pos.y))
 {
  loser= 1;
  return 1;
 }
 return 0;
}
   
// Fonction gnrique de jeu
// renvoie:
// 0 si le joueur 0 gagne,
// 1 si le joueur 1 gagne,
char game(char mode)
{
 while(1)
 {
  /* Gestion */
  {
   physicall(mode);
  }
   /* Dessin */
  {
   drawall(mode);
  }
  temps(game_speed);
  game_speed= game_defaultspeed;
  if (testfinish(mode)) break;
  //if (testkey(K_MENU)) temps(25000);
 }
 // En mode 1 joueur, on retourne 0
 // En mode 2 joueur, on retourne le perdant
 return loser;
}

// Affichage des commandes en solo
void display_1Pcommand()
{
 dbclear(buffer);
 draw_string(0, 0, "KEYBOARD: F1 AND F6",2);
 draw_string(0, 6, "PRESS      FOR BEGIN...", 2);
 draw_string((6 * 5), 6, "DOWN", 1);
 refresh();	  
 assombrir();
 waitkey(K_DOWN);
}

// Affichage du score en solo
void display_1Pscore()
{
 eclaircir();
 dbclear(buffer);
 draw_string(0, 0, "YOU LOSE.", 2);
 draw_string(0, 6, "YOUR SCORE IS:", 2);
 draw_number((15 * 5), 6, balle.score, 8, 1);
 draw_string(0, 12, "PRESS    ...", 2);
 draw_string((6 * 5), 12, "ESC", 1);   
 refresh();
 assombrir();
 waitkey(K_ESC);
 eclaircir();
}

// Lancer le jeu en solo
void game_1P()
{
 init_game_1P();
 display_1Pcommand();

 game(GAME_1P);

 display_1Pscore();
}

// Lancer le jeu en solo, dur
void game_1Phard()
{
 init_game_1Phard();
 display_1Pcommand();

 game(GAME_1P);

 display_1Pscore();
}

// Afficher les commandes des 2 joueurs
void display_2Pcommands()
{
 dbclear(buffer);
 draw_string(0, 0, "KEYBOARD: LEFT AND RIGHT",2);
 draw_string(0, 6, "PLAYER 1: 0 AND POINT",2);
 draw_string(0, 12, "PLAYER 2: MINUS AND EXE",2);
 draw_string(0, 18, "PRESS      FOR BEGIN...", 2);
 draw_string((6 * 5), 18, "X10X", 1);
 refresh();
 assombrir();
 waitkey(K_X10X);
}

// Afficher les scores en multi, enemi
void display_2Penscore()
{
 eclaircir();
 dbclear(buffer);
 draw_string(0, 0, "PLAYER   LOSE.", 2);
 draw_number((7 * 5), 0, loser, 1, 1);
 draw_string(0, 6, "PRESS    ...", 2);
 draw_string((6 * 5), 6, "ESC", 1);   
 refresh();
 assombrir();
 waitkey(K_ESC);
 eclaircir();
}

// Lancer le jeu en ennemi
void game_2P_en()
{  
 char loser;
 init_game_2P();
 display_2Pcommands();

 game(GAME_2P);
 
 display_2Penscore();
}

// Afficher les score en multi, coop
void display_2Pcoopscore()
{
 eclaircir();
 dbclear(buffer);
 draw_string(0, 0, "YOU LOSE.", 2);
 draw_string(0, 6, "YOUR SCORE IS:", 2);
 draw_number((15 * 5), 6, balle.score, 8, 1);
 draw_string(0, 12, "PRESS    ...", 2);
 draw_string((6 * 5), 12, "ESC", 1);   
 refresh();
 assombrir();
 waitkey(K_ESC);
 eclaircir();
}

// Lancer le jeu en multi, coop
void game_2P_coop()
{
 init_game_2P();
 display_2Pcommands();

 game(GAME_2P);

 display_2Pcoopscore();
}

/* Effet de "fondu" ;p */

void assombrir()
{ 
 char i;
 for(i= 1; i <= game_contrast; i++)
 {
  contrast(i);
  temps(2500);
 }
}

void eclaircir()
{
 char i;
 for(i= game_contrast; i >= 1; i--)
 {
  contrast(i);
  temps(2500);
 }
}

// The logo qui dchire

void logo(void)
{
 eclaircir();

 // On affiche le logo

 disp_bmp(logo_c1, buffer);
 disp_bmp(logo_c2, buffer + 0x80);
 refresh();

 assombrir();

 temps(20000);

 eclaircir();

 // On affiche le logo

 disp_bmp(doglogo_c1, buffer);
 disp_bmp(doglogo_c2, buffer + 0x80);
 refresh();

 assombrir();

 temps(20000);

 eclaircir();

 dbclear(buffer);
 refresh();
}
