unsigned a,b;

#ifdef DBCOPYSCREEN
void dbcopyscreen(unsigned int sego, unsigned int segd)
{
	asm push es;
	asm push ds;
	asm push si;
	asm push di;

	asm mov ax,segd;
	asm mov es,ax;
	asm mov di,0;
	asm mov ax,sego;
	asm mov ds,ax;
	asm mov si,0;
	asm cld;
	asm mov cx,512;
	asm rep movsw;

	segd+= 0x80;
	sego+= 0x80;

	asm mov ax,segd;
	asm mov es,ax;
	asm mov di,0;
	asm mov ax,sego;
	asm mov ds,ax;
	asm mov si,0;
	asm cld;
	asm mov cx,512;
	asm rep movsw;

	asm pop di;
	asm pop si;
	asm pop ds;
	asm pop es;
}
#endif

#ifdef COPYSCREEN
void copyscreen(unsigned int sego, unsigned int segd)
{
	asm push es;
	asm push ds;
	asm push si;
	asm push di;

	asm mov ax,segd;
	asm mov es,ax;
	asm mov di,0;
	asm mov ax,sego;
	asm mov ds,ax;
	asm mov si,0;
	asm cld;
	asm mov cx,512;
	asm rep movsw;

	asm pop di;
	asm pop si;
	asm pop ds;
	asm pop es;
}
#endif

// Par Superna, affiche une image
typedef unsigned char BMPTabType[1024];
#ifdef DISP_BMP
void disp_bmp(BMPTabType BmpTab,unsigned int segm)
{
  asm{
       mov ax,segm
       mov es,ax
       mov si,BmpTab
       xor di,di
       mov cx,0x200
       cld
       rep movsw
     }
}
#endif


#ifdef CLEAR
// Efface le buffer choisi.
void clear(unsigned int segm)
{
  asm{
       mov ax,segm
       mov es,ax
       xor ax,ax
       xor di,di
       mov cx,0x200
       cld
       rep stosw
     }
}
#endif
	   
#ifdef DBCLEAR
// Efface le buffer choisi.
void dbclear(unsigned int segm)
{
  asm{
       mov ax,segm
       mov es,ax
       xor ax,ax
       xor di,di
       mov cx,0x200
       cld
       rep stosw
     }
  segm+= 0x80;
  asm{
       mov ax,segm
       mov es,ax
       xor ax,ax
       xor di,di
       mov cx,0x200
       cld
       rep stosw
     }
}
#endif


/* ----------------------------------------
     Fonctions d'affichage de sprites 8*8
      uniquement pour les modes d3 et db
   ---------------------------------------- */


// Affiche un sprite 8*8 pour mode D3 ou DB avec
// OR sans clipping, au buffer voulu.
#ifdef D8_OR
void d8_or(int x,int y,void* spr,unsigned int segm)
{
  asm{
       mov cx,x
       mov si,spr
       mov di,0x23E
       mov ax,0x1C
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       mov ch,0x8
     }
  loop:
  asm{
       xor al,al
       mov ah,ds:[si]
       shr ax,cl
       or es:[di],ax
       sub di,0x10
       inc si
       dec ch
       jne loop
     }
}
#endif

// Affiche un sprite 8*8 pour mode D3 ou DB avec
// AND (masque) sans clipping, au buffer voulu.
#ifdef D8_AND
void d8_and(int x,int y,void* spr,unsigned int segm)
{
  asm{
       mov cx,x
       mov si,spr
       mov di,0x23E
       mov ax,0x1C
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       mov ch,0x8
     }
  loop:
  asm{
       or ax,0xFFFF
       and ah,ds:[si]
       ror ax,cl
       and es:[di],ax
       sub di,0x10
       inc si
       dec ch
       jne loop
     }
}
#endif

// Affiche un sprite 8*8 pour mode D3 ou DB avec
// XOR sans clipping, au buffer voulu.
#ifdef D8_XOR
void d8_xor(int x,int y,void* spr,unsigned int segm)
{
  asm{
       mov cx,x
       mov si,spr
       mov di,0x23E
       mov ax,0x1C
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       mov ch,0x8
     }
  loop:
  asm{
       xor al,al
       mov ah,ds:[si]
       shr ax,cl
       xor es:[di],ax
       sub di,0x10
       inc si
       dec ch
       jne loop
     }
}
#endif

// Affiche un sprite 8*8 pour mode D3 ou DB avec
// OR avec clipping, au buffer voulu.
#ifdef D8CLIP_OR
void d8clip_or(int x,int y,void* spr,unsigned int segm)
{
  asm{
       mov cx,x
       mov si,spr
       mov di,0x23E
       mov ax,0x1C
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       cmp ax,0
       jge clipping
       add ax,0x80
       add di,0x10
     }
  clipping:
  asm{
       shr ax,0x3
       sub di,ax
       or bx,0xFFFF
       cmp cx,0x78   // on commence les tests du clipping ici
       jle leftclip
       cmp cx,0x7F
       jg end
       xor bl,bl
     }
  leftclip:
  asm{
       cmp cx,0
       jge downclip
       cmp cx,-7
       jl end
       xor bh,bh
     }
  downclip:
  asm{
       and cl,0x7
       mov ch,0x8
       mov ax,y
       cmp ax,0x38
       jle upclip
       cmp ax,0x3F
       jg end
       shl ch,0x3
       sub ch,al
       jmp loop
     }
  upclip:
  asm{
       cmp ax,0
       jge loop
       cmp ax,-7
       jl end
       sub si,ax
       neg ax
       sub ch,al
       mov ax,0x1C
       add ax,segm
       mov es,ax   // fin des tests de clipping
     }
  loop:
  asm{
       xor al,al
       mov ah,ds:[si]
       shr ax,cl
       and ax,bx
       or es:[di],ax
       sub di,0x10
       inc si
       dec ch
       jne loop
     }
  end:
}
#endif

// Affiche un sprite 8*8 pour mode D3 ou DB avec
// AND avec clipping, au buffer voulu.
#ifdef D8CLIP_AND
void d8clip_and(int x,int y,void* spr,unsigned int segm)
{
  asm{
       mov cx,x
       mov si,spr
       mov di,0x23E
       mov ax,0x1C
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       cmp ax,0
       jge clipping
       add ax,0x80
       add di,0x10
     }
  clipping:
  asm{
       shr ax,0x3
       sub di,ax
       mov ax,y
       xor bx,bx
       cmp cx,0x78   // on commence les tests du clipping ici
       jle leftclip
       cmp cx,0x7F
       jg end
       or bl,0xFF
       jmp downclip
     }
  leftclip:
  asm{
       cmp cx,0
       jge downclip
       cmp cx,-7
       jl end
       or bh,0xFF
     }
  downclip:
  asm{
       and cl,0x7
       mov ch,0x8
       cmp ax,0x38
       jle upclip
       cmp ax,0x3F
       jg end
       shl ch,0x3
       sub ch,al
       jmp loop
     }
  upclip:
  asm{
       cmp ax,0
       jge loop
       cmp ax,-7
       jl end
       sub si,ax
       neg ax
       sub ch,al
       mov ax,0x1C
       add ax,segm
       mov es,ax   // fin des tests de clipping
     }
  loop:
  asm{
       or ax,0xFFFF
       and ah,ds:[si]
       ror ax,cl
       or ax,bx
       and es:[di],ax
       sub di,0x10
       inc si
       dec ch
       jne loop
     }
  end:
}
#endif

// Affiche un sprite 8*8 pour mode D3 ou DB avec
// XOR avec clipping, au buffer voulu.
#ifdef D8CLIP_XOR
void d8clip_xor(int x,int y,void* spr,unsigned int segm)
{
  asm{
       mov cx,x
       mov si,spr
       mov di,0x23E
       mov ax,0x1C
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       cmp ax,0
       jge clipping
       add ax,0x80
       add di,0x10
     }
  clipping:
  asm{
       shr ax,0x3
       sub di,ax
       or bx,0xFFFF
       cmp cx,0x78   // on commence les tests du clipping ici
       jle leftclip
       cmp cx,0x7F
       jg end
       xor bl,bl
     }
  leftclip:
  asm{
       cmp cx,0
       jge downclip
       cmp cx,-7
       jl end
       xor bh,bh
     }
  downclip:
  asm{
       and cl,0x7
       mov ch,0x8
       mov ax,y
       cmp ax,0x38
       jle upclip
       cmp ax,0x3F
       jg end
       shl ch,0x3
       sub ch,al
       jmp loop
     }
  upclip:
  asm{
       cmp ax,0
       jge loop
       cmp ax,-7
       jl end
       sub si,ax
       neg ax
       sub ch,al
       mov ax,0x1C
       add ax,segm
       mov es,ax   // fin des tests de clipping
     }
  loop:
  asm{
       xor al,al
       mov ah,ds:[si]
       shr ax,cl
       and ax,bx
       xor es:[di],ax
       sub di,0x10
       inc si
       dec ch
       jne loop
     }
  end:
}
#endif

/* ----------------------------------------
    Fonctions d'affichage de sprites 16*16
      uniquement pour les modes d3 et db
   ---------------------------------------- */


// Affiche un sprite 16*16 pour mode D3 ou DB
// avec OR sans clipping, au buffer voulu.
#ifdef D16_OR
void d16_or(int x,int y,void* spr,unsigned int segm)
{
  asm{
       mov cx,x
       mov si,spr
       mov di,0x27E
       mov ax,0x18
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       mov ch,0x10
     }
  loop:
  asm{
       xor dl,dl
       mov ax,ds:[si]
       mov dh,al
       shr ax,cl
       shr dx,cl
       or es:[di],ax
       or es:[di-0x1],dl
       sub di,0x10
       add si,0x2
       dec ch
       jne loop
     }
}
#endif

// Affiche un sprite 16*16 pour mode D3 ou DB
// avec AND sans clipping, au buffer voulu.
#ifdef D16_AND
void d16_and(int x,int y,void* spr,unsigned int segm)
{
  asm{
       mov cx,x
       mov si,spr
       mov di,0x27E
       mov ax,0x18
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       mov ch,0x10
     }
  loop:
  asm{
       or dl,0xFF
       mov ax,ds:[si]
       mov dh,al
       not ax
       shr ax,cl
       shr dx,cl
       not ax
       and es:[di],ax
       and es:[di-0x1],dl
       sub di,0x10
       add si,0x2
       dec ch
       jne loop
     }
}
#endif

// Affiche un sprite 16*16 pour mode D3 ou DB
// avec XOR sans clipping, au buffer voulu.
#ifdef D16_XOR
void d16_xor(int x,int y,void* spr,unsigned int segm)
{
  asm{
       mov cx,x
       mov si,spr
       mov di,0x27E
       mov ax,0x18
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       mov ch,0x10
     }
  loop:
  asm{
       xor dl,dl
       mov ax,ds:[si]
       mov dh,al
       shr ax,cl
       shr dx,cl
       xor es:[di],ax
       xor es:[di-0x1],dl
       sub di,0x10
       add si,0x2
       dec ch
       jne loop
     }
}
#endif

// Affiche un sprite 16*16 pour mode D3 ou DB
// avec OR avec clipping, au buffer voulu.
#ifdef D16CLIP_OR
void d16clip_or(int x,int y,void* spr,unsigned int segm)
{
  unsigned char el=0xFF;
  asm{
       mov cx,x
       mov si,spr
       mov di,0x27E
       mov ax,0x18
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       cmp ax,0
       jge clipping
       add ax,0x80
       add di,0x10
     }
  clipping:
  asm{
       shr ax,0x3
       sub di,ax
       or bx,0xFFFF
       cmp cx,0x70   // on commence les tests du clipping ici
       jle leftclip
       cmp cx,0x7F
       jg end
       xor el,bl
       cmp cx,0x78
       jl downclip
       xor bl,bl
       jmp downclip
     }
  leftclip:
  asm{
       cmp cx,0
       jge downclip
       cmp cx,-15
       jl end
       xor bh,bh
       cmp cx,-8
       jge downclip
       xor bl,bl
     }
  downclip:
  asm{
       and cl,0x7
       mov ch,0x10
       mov ax,y
       cmp ax,0x30
       jle upclip
       cmp ax,0x3F
       jg end
       shl ch,0x2
       sub ch,al
       jmp loop
     }
  upclip:
  asm{
       cmp ax,0
       jge loop
       cmp ax,-15
       jl end
       mov dx,ax
       shl ax,0x1
       sub si,ax
       neg dx
       sub ch,dl
       mov ax,0x18
       add ax,segm
       mov es,ax   // fin des tests de clipping
     }
  loop:
  asm{
       xor dl,dl
       mov ax,ds:[si]
       mov dh,al
       shr ax,cl
       shr dx,cl
       and ax,bx
       and dl,el
       or es:[di],ax
       or es:[di-1],dl
       sub di,0x10
       add si,0x2
       dec ch
       jne loop
     }
  end:
}
#endif

// Affiche un sprite 16*16 pour mode D3 ou DB
// avec AND avec clipping, au buffer voulu.
#ifdef D16CLIP_AND
void d16clip_and(int x,int y,void* spr,unsigned int segm)
{
  unsigned char el=0;
  asm{
       mov cx,x
       mov si,spr
       mov di,0x27E
       mov ax,0x18
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       cmp ax,0
       jge clipping
       add ax,0x80
       add di,0x10
     }
  clipping:
  asm{
       shr ax,0x3
       sub di,ax
       xor bx,bx
       cmp cx,0x70   // on commence les tests du clipping ici
       jle leftclip
       cmp cx,0x7F
       jg end
       or al,0xFF
       or el,al
       cmp cx,0x78
       jl downclip
       or bl,0xFF
       jmp downclip
     }
  leftclip:
  asm{
       cmp cx,0
       jge downclip
       cmp cx,-15
       jl end
       or bh,0xFF
       cmp cx,-8
       jge downclip
       or bl,0xFF
     }
  downclip:
  asm{
       and cl,0x7
       mov ch,0x10
       mov ax,y
       cmp ax,0x30
       jle upclip
       cmp ax,0x3F
       jg end
       shl ch,0x2
      sub ch,al
      jmp loop
    }
  upclip:
  asm{
       cmp ax,0
       jge loop
       cmp ax,-15
       jl end
       mov dx,ax
       shl ax,0x1
       sub si,ax
       neg dx
       sub ch,dl
       mov ax,0x18
       add ax,segm
       mov es,ax   // fin des tests de clipping
     }
  loop:
  asm{
       or dl,0xFF
       mov ax,ds:[si]
       mov dh,al
       not ax
       shr ax,cl
       shr dx,cl
       not ax
       or ax,bx
       or dl,el
       and es:[di],ax
       and es:[di-1],dl
       sub di,0x10
       add si,0x2
       dec ch
       jne loop
     }
  end:
}
#endif

// Affiche un sprite 16*16 pour mode D3 ou DB
// avec XOR avec clipping, au buffer voulu.
#ifdef D16CLIP_XOR
void d16clip_xor(int x,int y,void* spr,unsigned int segm)
{
  unsigned char el=0xFF;
  asm{
       mov cx,x
       mov si,spr
       mov di,0x27E
       mov ax,0x18
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       cmp ax,0
       jge clipping
       add ax,0x80
       add di,0x10
     }
  clipping:
  asm{
       shr ax,0x3
       sub di,ax
       or bx,0xFFFF
       cmp cx,0x70   // on commence les tests du clipping ici
       jle leftclip
       cmp cx,0x7F
       jg end
       xor el,bl
       cmp cx,0x78
       jl downclip
       xor bl,bl
       jmp downclip
     }
  leftclip:
  asm{
       cmp cx,0
       jge downclip
       cmp cx,-15
       jl end
       xor bh,bh
       cmp cx,-8
       jge downclip
       xor bl,bl
     }
  downclip:
  asm{
       and cl,0x7
       mov ch,0x10
       mov ax,y
       cmp ax,0x30
       jle upclip
       cmp ax,0x3F
       jg end
       shl ch,0x2
       sub ch,al
       jmp loop
     }
  upclip:
  asm{
       cmp ax,0
       jge loop
       cmp ax,-15
       jl end
       mov dx,ax
       shl ax,0x1
       sub si,ax
       neg dx
       sub ch,dl
       mov ax,0x18
       add ax,segm
       mov es,ax   // fin des tests de clipping
     }
  loop:
  asm{
       xor dl,dl
       mov ax,ds:[si]
       mov dh,al
       shr ax,cl
       shr dx,cl
       and ax,bx
       and dl,el
       xor es:[di],ax
       xor es:[di-1],dl
       sub di,0x10
       add si,0x2
       dec ch
       jne loop
     }
  end:
}
#endif

/* ---------------------------------------
           Fonctions concernant la
             gestion d'une ligne
   --------------------------------------- */


// Affiche une ligne verticale noire en mode DB.
#ifdef BVLINE
void bvline(unsigned int x,unsigned int ymin,unsigned int ymax,unsigned int segm)
{
  asm{
      mov cx,x
      mov dl,0x80
      mov di,0x1FF
      mov ax,0x20
      add ax,segm
      sub ax,ymax
      mov es,ax
      mov ax,cx
      shr ax,0x3
      sub di,ax
      and cl,0x7
      shr dl,cl
      mov cx,ymax
      sub cx,ymin
      inc cx
    }
  loop:
  asm{
       or es:[di],dl
       or es:[di+0x800],dl
       add di,0x10
       dec cx
       jne loop
     }
}
#endif

// Affiche une ligne verticale blanche en mode DB.
#ifdef WVLINE
void wvline(unsigned int x,unsigned int ymin,unsigned int ymax,unsigned int segm)
{
  asm{
       mov cx,x
       mov dl,0x7F
       mov di,0x1FF
       mov ax,0x20
       add ax,segm
       sub ax,ymax
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       ror dl,cl
       mov cx,ymax
       sub cx,ymin
       inc cx
     }
  loop:
  asm{
       and es:[di],dl
       and es:[di+0x800],dl
       add di,0x10
       dec cx
       jne loop
     }
}
#endif

// Affiche une ligne verticale grise en mode DB.
#ifdef GVLINE
void gvline(unsigned int x,unsigned int ymin,unsigned int ymax,unsigned int segm)
{
  asm{
       mov cx,x
       mov dx,0x807F
       mov di,0x1FF
       mov ax,0x20
       add ax,segm
       sub ax,ymax
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dh,cl
       ror dl,cl
       mov cx,ymax
       sub cx,ymin
       inc cx
     }
  loop:
  asm{
       or es:[di],dh
       and es:[di+0x800],dl
       add di,0x10
       dec cx
       jne loop
     }
}
#endif

// Inverse une ligne verticale en mode DB.
#ifdef INVVLINE
void invvline(unsigned int x,unsigned int ymin,unsigned int ymax,unsigned int segm)
{
  asm{
       mov cx,x
       mov dl,0x80
       mov di,0x1FF
       mov ax,0x20
       add ax,segm
       sub ax,ymax
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dl,cl
       mov cx,ymax
       sub cx,ymin
       inc cx
     }
  loop:
  asm{
       xor es:[di],dl
       xor es:[di+0x800],dl
       add di,0x10
       dec cx
       jne loop
     }
}
#endif

// Affiche une ligne verticale en mode DB avec la couleur choisie.
// Vitesse incomparable par rapport a une fonction du type :
// for (...) pxl(...);
#ifdef VLINE
void vline(unsigned int x,unsigned int ymin,unsigned int ymax,unsigned char couleur,unsigned int segm)
{
  switch (couleur)
  {
    case 2  : gvline(x,ymin,ymax,segm);break;
    case 1  : bvline(x,ymin,ymax,segm);break;
    case 0  : wvline(x,ymin,ymax,segm);break;
    default : invvline(x,ymin,ymax,segm);
  }
}
#endif

// Affiche une ligne horizontale noire en mode DB.
#ifdef BHLINE
void bhline(unsigned int xmin,unsigned int xmax,unsigned int y,unsigned int segm)
{
  asm{
       mov cx,xmin
       or dx,0xFFFF
       mov di,0x1FF
       mov si,di
       mov ax,0x20
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dh,cl
       mov cx,xmax
       mov ax,cx
       shr ax,0x3
       sub si,ax
       and cl,0x7
       inc cl
       shr dl,cl
       not dl
       mov cx,di
       sub cx,si
       je samebyte
       dec cx
       je sameword
       or es:[di],dh
       or es:[di+0x800],dh
       or es:[si],dl
       or es:[si+0x800],dl
       or al,0xFF
     }
  loop:
  asm{
       inc si
       or es:[si],al
       or es:[si+0x800],al
       dec cx
       jne loop
     }
  return;
  samebyte:
  asm{
       and dl,dh
       or es:[di],dl
       or es:[di+0x800],dl
     }
  return;
  sameword:
  asm{
       or es:[si],dx
       or es:[si+0x800],dx
     }
}
#endif

// Affiche une ligne horizontale blanche en mode DB.
#ifdef WHLINE
void whline(unsigned int xmin,unsigned int xmax,unsigned int y,unsigned int segm)
{
  asm{
       mov cx,xmin
       or dx,0xFFFF
       mov di,0x1FF
       mov si,di
       mov ax,0x20
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dh,cl
       not dh
       mov cx,xmax
       mov ax,cx
       shr ax,0x3
       sub si,ax
       and cl,0x7
       inc cl
       shr dl,cl
       mov cx,di
       sub cx,si
       je samebyte
       dec cx
       je sameword
       and es:[di],dh
       and es:[di+0x800],dh
       and es:[si],dl
       and es:[si+0x800],dl
       xor al,al
     }
  loop:
  asm{
       inc si
       and es:[si],al
       and es:[si+0x800],al
       dec cx
       jne loop
     }
  return;
  samebyte:
  asm{
       or dl,dh
       and es:[di],dl
       and es:[di+0x800],dl
     }
  return;
  sameword:
  asm{
       and es:[si],dx
       and es:[si+0x800],dx
     }
}
#endif

// Affiche une ligne horizontale grise en mode DB.
#ifdef GHLINE
void ghline(unsigned int xmin,unsigned int xmax,unsigned int y,unsigned int segm)
{
  asm{
       mov cx,xmin
       or dh,0xFF
       or bl,0xFF
       mov di,0x1FF
       mov si,di
       mov ax,0x20
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dh,cl
       mov bh,dh
       not bh
       mov cx,xmax
       mov ax,cx
       shr ax,0x3
       sub si,ax
       and cl,0x7
       inc cl
       shr bl,cl
       mov dl,bl
       not dl
       mov cx,di
       sub cx,si
       je samebyte
       dec cx
       je sameword
       or es:[di],dh
       and es:[di+0x800],bh
       or es:[si],dl
       and es:[si+0x800],bl
       mov ax,0xFF00
     }
  loop:
  asm{
       inc si
       or es:[si],ah
       and es:[si+0x800],al
       dec cx
       jne loop
     }
  return;
  samebyte:
  asm{
       and dl,dh
       or bl,bh
       or es:[di],dl
       and es:[di+0x800],bl
     }
  return;
  sameword:
  asm{
       or es:[si],dx
       and es:[si+0x800],bx
     }
}
#endif

// Inverse une ligne horizontale en mode DB.
#ifdef INVHLINE
void invhline(unsigned int xmin,unsigned int xmax,unsigned int y,unsigned int segm)
{
  asm{
       mov cx,xmin
       or dx,0xFFFF
       mov di,0x1FF
       mov si,di
       mov ax,0x20
       add ax,segm
       sub ax,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dh,cl
       mov cx,xmax
       mov ax,cx
       shr ax,0x3
       sub si,ax
       and cl,0x7
       inc cl
       shr dl,cl
       not dl
       mov cx,di
       sub cx,si
       je samebyte
       dec cx
       je sameword
       xor es:[di],dh
       xor es:[di+0x800],dh
       xor es:[si],dl
       xor es:[si+0x800],dl
       or al,0xFF
     }
  loop:
  asm{
       inc si
       xor es:[si],al
       xor es:[si+0x800],al
       dec cx
       jne loop
     }
  return;
  samebyte:
  asm{
       and dl,dh
       xor es:[di],dl
       xor es:[di+0x800],dl
     }
  return;
  sameword:
  asm{
       xor es:[si],dx
       xor es:[si+0x800],dx
     }
}
#endif

// Affiche une ligne horizontale en mode DB avec la couleur choisie.
// Vitesse incomparable par rapport a une fonction du type :
// for (...) pxl(...);
#ifdef HLINE
void hline(unsigned int xmin,unsigned int xmax,unsigned int y,unsigned char couleur,unsigned int segm)
{
  switch (couleur)
  {
    case 2  : ghline(xmin,xmax,y,segm);break;
    case 1  : bhline(xmin,xmax,y,segm);break;
    case 0  : whline(xmin,xmax,y,segm);break;
    default : invhline(xmin,xmax,y,segm);
  }
}
#endif

/* ---------------------------------------
       Fonctions concernant la gestion
               d'un seul pixel
   --------------------------------------- */


// Dessine un pixel noir en mode DB
#ifdef BPXL
void bpxl(unsigned int x,unsigned char y,unsigned int segm)
{
  asm{
       mov cx,x
       mov dl,0x80
       mov di,0x1FF
       mov ax,0x20
       add ax,segm
       sub al,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dl,cl
       or es:[di],dl
       or es:[di+0x800],dl
     }
}
#endif

// Dessine un pixel blanc en mode DB
#ifdef WPXL
void wpxl(unsigned int x,unsigned char y,unsigned int segm)
{
  asm{
       mov cx,x
       mov dl,0x7F
       mov di,0x1FF
       mov ax,0x20
       add ax,segm
       sub al,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       ror dl,cl
       and es:[di],dl
       and es:[di+0x800],dl
     }
}
#endif

// Dessine un pixel gris en mode DB
#ifdef GPXL
void gpxl(unsigned int x,unsigned char y,unsigned int segm)
{
  asm{
       mov cx,x
       mov dl,0x80
       mov di,0x1FF
       mov ax,0x20
       add ax,segm
       sub al,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dl,cl
       or es:[di],dl
       not dl
       and es:[di+0x800],dl
     }
}
#endif

// Inverse un pixel en mode DB
#ifdef INVPXL
void invpxl(unsigned int x,unsigned char y,unsigned int segm)
{
  asm{
       mov cx,x
       mov dl,0x80
       mov di,0x1FF
       mov ax,0x20
       add ax,segm
       sub al,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dl,cl
       xor es:[di],dl
       xor es:[di+0x800],dl
     }
}
#endif

// Determine si le pixel est allume ou eteint
// en mode D3 ou DB, sur un seul buffer.
#ifdef PXLTEST
unsigned char pxltest(unsigned int x,unsigned char y,unsigned int segm)
{
  asm{
       mov cx,x
       mov dx,0x8080
       mov di,0x1FF
       mov ax,0x20
       add ax,segm
       sub al,y
       mov es,ax
       mov ax,cx
       shr ax,0x3
       sub di,ax
       and cl,0x7
       shr dx,cl
       and dl,es:[di]
       and dh,es:[di+0x800]
       cmp dx,0x0
       je end
       inc cl
       rol dx,cl
       add dl,dh
       xor dl,0x3
     }
  end:
  return _DL;
}
#endif

// Dessine un pixel en fonction de la couleur (ou inversion) choisie.
#ifdef PXL
void pxl(unsigned int x,unsigned char y,unsigned char couleur,unsigned int segm)
{
  switch (couleur)
  {
    case 2  : gpxl(x,y,segm);break;
    case 1  : bpxl(x,y,segm);break;
    case 0  : wpxl(x,y,segm);break;
    default : invpxl(x,y,segm);
  }
}
#endif

/* ---------------------------------------
           Fonctions de scrolling
   --------------------------------------- */


// Decale tout le buffer choisi(segm) vers la gauche et
// rajoute la colonne designee par x sur le buffer choisi
// (srcsegm).Relativement lent.
#ifdef RIGHTSCROLL
void rightscroll(unsigned int x,unsigned int srcsegm,unsigned int segm)
{
  asm{
       mov si,0xF       // met 15 dans si (bloc de donnee en bas a gauche du buffer)
       xor di,di        // efface di, di=0 (bloc de donnee en bas a droite)
       mov ax,segm      // met le buffer choisi
       mov es,ax
       mov ax,srcsegm   // met dans ax le buffer source
       sub ax,segm      // ax=srcsegm-segm;
       shl ax,0x4       // ax*=16; calcule le nombre de bloc de donnee entre srcsegm et segm
       add si,ax        // met dans si la ligne du bloc de donnee de la colonne a faire apparaitre
       mov dh,0x40      // dh=64; nombre de fois a repeter la boucle(nombre de lignes d'un buffer)
       mov cx,x         // cx prends la valeur de x
       mov ax,cx        // ax prends la valeur de x
       shr ax,0x3       // ax/=8; calcul pour determiner "l'abscisse" du bloc de donnee source
       sub si,ax        // si = valeur exacte du bloc de donnee source a utiliser
       and cl,0x7       // calcul du decalage en fonction de x
       inc cl           // ajoute 1 a cl pour que le calcul soit exact
     }
  loopline:             // debut de la double boucle
  asm{
       mov bl,es:[si]   // bl = bloc de donnee source
       rol bl,cl        // decalage de bl pour faire correspondre le bit voulu au niveau du bit 0
       and bl,0x1       // efface les bits inutiles (de 1 a 7) et garde le bit 0
       mov ch,0x8       // ch=8; nombre de fois a repeter la deuxieme boucle (nombre de mots sur une ligne 8*16=64)
       add si,0x10      // si+=16; augmente le bloc de donnee source d'une ligne
     }
  loop:                 // la deuxieme boucle
  asm{
       mov ax,es:[di]   // ax = bloc de destination
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,0x1       // passe le 7eme bit au bit 0 par un decalage
       and dl,0x1       // on garde le bit 0 de dl
       shl ax,0x1       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       mov es:[di],ax   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl
       add di,0x2       // passe au bloc de destination suivant
       dec ch           // decremente ch (ch correspond au nombre de bytes dans une ligne)
       jne loop         // continue la boucle tant que ch different de 0
       dec dh           // decremente dh (dh correspond au nombre de ligne dans un buffer)
       jne loopline
     }
}
#endif

// Decale tout le buffer choisi(segm) vers la droite et
// rajoute la colonne designee par x du buffer choisi
// (srcsegm) sur l'autre buffer choisi(segm).
// Relativement lent.
#ifdef LEFTSCROLL
void leftscroll(unsigned int x,unsigned int srcsegm,unsigned int segm)
{
  asm{
       mov si,0x3FF     // met 1023 dans si (bloc de donnee en haut a gauche du buffer)
       mov di,0x3FE     // met 1022 dans di (bloc de donnee en haut a gauche-1)
       mov ax,segm      // met le buffer choisi
       mov es,ax
       mov ax,srcsegm   // met dans ax le buffer source
       sub ax,segm      // ax=srcsegm-segm;
       shl ax,0x4       // ax*=16; calcule le nombre de bloc de donnee entre srcsegm et segm
       add si,ax        // met dans si la ligne du bloc de donnee de la colonne a faire apparaitre
       mov dh,0x40      // dh=64; nombre de fois a repeter la boucle(nombre de lignes d'un buffer)
       mov cx,x         // cx prends la valeur de x
       mov ax,cx        // ax prends la valeur de x
       shr ax,0x3       // ax/=8; calcul pour determiner "l'abscisse" du bloc de donnee source
       sub si,ax        // si = valeur exacte du bloc de donnee source a utiliser
       and cl,0x7       // calcul du decalage en fonction de x
     }
  loopline:             // debut de la double boucle
  asm{
       mov bl,es:[si]   // bl = bloc de donnee source
       shl bl,cl        // decalage de bl pour faire correspondre le bit voulu au niveau du bit 7
       and bl,0x80      // efface les bits inutiles (de 0 a 6) et garde le bit 7
       mov ch,0x8       // ch=8; nombre de fois a repeter la deuxieme boucle (nombre de mots sur une ligne 8*16=64)
       sub si,0x10      // si-=16; descend le bloc de donnee source d'une ligne
     }
  loop:                 // la deuxieme boucle
  asm{
       mov ax,es:[di]   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,0x1       // on garde le bit 0 de dl
       ror dl,0x1       // et on le passe au 7eme bit de dl
       shr ax,0x1       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       mov es:[di],ax   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl
       sub di,0x2       // passe au bloc de destination suivant
       dec ch           // decremente ch (ch correspond au nombre de bytes dans une ligne)
       jne loop         // continue la boucle tant que ch different de 0
       dec dh           // decremente dh (dh correspond au nombre de ligne dans un buffer)
       jne loopline
     }
}
#endif

// Decale tout le buffer choisi(segm) vers le bas et
// rajoute la ligne designee par y du buffer choisi
// (srcsegm) sur l'autre buffer choisi(segm).
// Relativement lent.
#ifdef UPSCROLL
void upscroll(unsigned int y,unsigned int srcsegm,unsigned int segm)
{
  asm{
       mov ax,segm      // met le buffer choisi
       mov es,ax
       mov di,0x10      // di=16; (bloc de donnee en bas a droite au dessus de l'octet 0)
       mov si,srcsegm   // si=srcsegm
       sub si,segm      // si=(srcsegm-segm)
       sub si,y         // si=(srcsegm-segm-y)
       shl si,0x4       // si=(srcsegm-segm-y)*16
       add si,0x3F0     // si=((srcsegm-segm-y)*16)+1007 -> si pointe vers le bon octet
       mov cx,0x1F8     // nombre de fois a repeter la boucle (8*63=504)
     }
  loopline:
  asm{
       mov ax,es:[di]   // copie dans ax le mot pointe par di
       mov es:[di-0x10],ax // copie ax sur le mot en dessous du mot pointe par di
       add di,0x2       // passe au mot suivant
       dec cx           // decremente cx
       jne loopline     // tant que cx different de 0, continue la boucle
       or ch,0x8        // ch=0
       sub di,0x10      // retire 16 a di pour qu'il pointe sur le bon octet
     }
  loop:
  asm{
       mov ax,es:[si]   // copie le mot de la ligne choisie dans ax
       mov es:[di],ax   // copie ax sur le mot pointe par di
       add di,0x2       // passe au mot suivant sur le buffer choisi (segm)
       add si,0x2       // passe au mot de la ligne choisie suivant
       dec ch           // decremente ch
       jne loop         // tant que ch different de 0, continue la boucle
     }
}
#endif

// Decale tout le buffer choisi(segm) vers le haut et
// rajoute la ligne designee par y du buffer choisi
// (srcsegm) sur l'autre buffer choisi(segm).
// Relativement lent.
#ifdef DOWNSCROLL
void downscroll(unsigned int y,unsigned int srcsegm,unsigned int segm)
{
  asm{
       mov ax,segm      // met le buffer choisi
       mov es,ax
       mov di,0x3EE     // di=1006; (bloc de donnee en haut a gauche au dessous de l'octet 1022)
       mov si,srcsegm   // si=srcsegm
       sub si,segm      // si=(srcsegm-segm)
       sub si,y         // si=(srcsegm-segm-y)
       shl si,0x4       // si=(srcsegm-segm-y)*16
       add si,0x3FE     // si=((srcsegm-segm-y)*16)+1022 -> si pointe vers le bon octet
       mov cx,0x1F8     // nombre de fois a repeter la boucle (8*63=504)
     }
  loopline:
  asm{
       mov ax,es:[di]   // copie dans ax le mot pointe par di
       mov es:[di+0x10],ax // copie ax sur le mot au dessus du mot pointe par di
       sub di,0x2       // passe au mot suivant
       dec cx           // decremente cx
       jne loopline     // tant que cx different de 0, continue la boucle
       or ch,0x8        // ch=0
       add di,0x10      // ajoute 16 a di pour qu'il pointe sur le bon octet
    }
  loop:
  asm{
       mov ax,es:[si]   // copie le mot de la ligne choisie dans ax
       mov es:[di],ax   // copie ax sur le mot pointe par di
       sub di,0x2       // passe au mot suivant sur le buffer choisi (segm)
       sub si,0x2       // passe au mot de la ligne choisie suivant
       dec ch           // decremente ch
       jne loop         // tant que ch different de 0, continue la boucle
     }
}
#endif
