#ifdef MODE
// Passe au mode voulu : C3, DB... etc
void mode(unsigned char modetype) 
{
  asm{
       mov al,modetype
       out 0x2,al
     }
}
#endif

#ifdef MOVEVIDEO
// Par Libithium, met le buffer voulu comme adresse d'origine
void movevideo(unsigned int segm)
{
  asm{
       mov ax,segm
       xor dx,dx
       shl ax,0x1
       rcl dx,0x1
       shl ax,0x1
       rcl dx,0x1
       shl ax,0x1
       rcl dx,0x1
       shl ax,0x1
       rcl dx,0x1
       out 0x05,ax
       mov al,dl
       out 0x07,al
     }
}
#endif

#ifdef SHUTCALC
// Par Whyp, eteint la calculatrice
void shutcalc() 
{
  asm{
       mov al,0x8
       out 0xC,al
     }
}
#endif

// Initialise le contraste
// Mais attention aux problemes de compatibilite
// entre g100 et g100+.
#ifdef CONTRAST
void contrast(unsigned char niv) 
{ 
  asm{ 
       mov ax,0x40       // Ŀ 
       mov es,ax         // g 100g100+ 
       mov al,niv        // Ĵ 
       shl al,0x1        //   0    0    contraste minimal 
       add ax,0x2210     //   8    9    contraste normal 
       mov es:0xE5,al    //   12   12   contraste initial 
       xor bl,bl         //   15   16   contraste optimal pour le gris 
       int 0x7C          //   22   22   contraste maximal 
     }                   //  
}
#endif


// permet d'augmenter ou diminuer le contraste d'un certain niveau.
#ifdef GET_CONTRAST
unsigned char get_contrast() 
{ 
  asm{ 
       mov ax,0x40 
       mov es,ax 
       mov al,es:0xE5 
       sub al,0x12 
       shr al,0x1 
     } 
  return _AL; 
} 
#endif
