
// Teste une touche.Cette fonction sert aux touches multiples
// Fonction en partie inspiree de celle de Superna.
// La valeur de x va de 1 (colonne de F1) a 7 (AC/on) avec
// par exemle 4 pour la colonne de F4.
// La valeur de y va de 0 (AC/on) a 10 (F1-F6) avec 9 pour les
// touches multidirectionnelles et par exmeple 5 pour la ligne
// de a+b/c.

#ifdef TESTKEY
// Pour tester une touche, par exemple EXE, il suffit de mettre :
// testkey(K_EXE);
#define K_0	1,1
#define K_POINT 2,1
#define K_X10X 3,1
#define K_LITTLEMINUS 4,1
#define K_EXE 5,1
#define K_1	1,2
#define K_2	2,2
#define K_3	3,2
#define K_PLUS 4,2
#define K_MINUS	5,2
#define K_4	1,3
#define K_5	2,3
#define K_6	3,3
#define K_MULTIPLY 4,3
#define K_DIVIDE 5,3
#define K_7	4,1
#define K_8	4,2
#define K_9	4,3
#define K_DEL 4,4
#define K_ON 5,4
#define K_ABC 1,5
#define K_X2 2,5
#define K_LEFTBRACKET 3,5
#define K_RIGHTBRACKET 4,5
#define K_COMMA	5,5
#define K_ARROW	6,5
#define K_XOT 1,6
#define K_LOG 2,6
#define K_LN 3,6
#define K_SIN 4,6
#define K_COS 5,6
#define K_TAN 6,6
#define K_ALPHA	1,7
#define K_VARS 2,7
#define K_POW 3,7
#define K_ESC 4,7
#define K_SHIFT	1,8
#define K_CTRL 2,8
#define K_OPTN 3,8
#define K_MENU 4,8
#define K_LEFT 1,9
#define K_UP 2,9
#define K_DOWN 3,9
#define K_RIGHT	4,9
#define K_F1 1,10
#define K_F2 2,10
#define K_F3 3,10
#define K_F4 4,10
#define K_F5 5,10
#define K_F6 6,10

unsigned char testkey(unsigned char x,unsigned char y)
{
  asm{
       mov ax,0x1
       mov bl,al
       mov cl,y
       shl ax,cl
       mov cl,x
       inc cl
       ror bl,cl
       out 0x13,ax
       mov ch,0xA
     }
  loop:
  asm{
       dec ch
       jne loop
       in al,0x13
       and al,bl
     }
  if (_AL) return 1;
  return 0;
}
#endif


// teste une meme touche ou un meme groupe de touche
// sur la meme ligne ou des lignes differentes.
// Fonction plus rapide que testkey() mais
// attention aux valeurs appliquees a y et group...
// Pour savoir quelles valeurs mettre, utiliser Touche v 3.8
// de 2072 : pour y -> lire la valeur de "rows" et pour
// group -> lire la valeur de "P-13h".

#ifdef TESTGROUP

unsigned char testgroup(unsigned char group,unsigned int y)
{
  asm{
       mov ax,y
       mov dl,group
       out 0x13,ax
       mov cx,0xA
     }
  loop:
  asm{
       dec cx
       jne loop
       in al,0x13
       and al,dl
     }
  if(_AL) return 1;
  return 0;
}


// Attends qu'aucunes des touches du clavier ne soient pressees.
void emptykey()
{
  do
  {
    while (testgroup(0x7F,0x7FF)); // On teste toute les touches.
  } while (testgroup(0x7F,0x7FF)); // On refait le test pour eviter un bug bizarre.
}
#endif

#ifdef KEYINT
// Desactive l'interruption 9. Par Superna
int OldInt9Seg,OldInt9Off; // adresses de l'interruption 9

void disable9()
{
  asm{
       xor ax,ax
       mov es,ax
       mov ax,es:0x26     // Segment interruption 9
       mov OldInt9Seg,ax  // stocke dans variable
       mov ax,es:0x24     // Offset int9
       mov OldInt9Off,ax  // stocke dans variable
       mov ax,es:0x03FE   // segment int FF
       mov es:0x26,ax     // remplace seg 9 par seg FF
       mov ax,es:0x03FC   // offset int FF
       mov es:0x24,ax     // remplace offset 9 par offset FF
     }
}


// Active l'interruption 9. Par Superna
void enable9()
{
  asm{
       xor ax,ax
       mov es,ax
       mov ax,OldInt9Seg
       mov es:0x26,ax     // remet segment d'origine
       mov ax,OldInt9Off
       mov es:0x24,ax     // remet offset d'origine
     }
}
#endif

#ifdef EMPTYBUF
void emptybuf() 
{ 
  asm{ 
       mov ax,0x40 
       mov es,ax 
       mov al,es:0x1B 
       mov es:0x1D,al 
     } 
} 
#endif